#include "testApp.h"

//- - - - - - - - - - -//\\ - - - - - - - - - - - - - - - - - - - - - - - - - 
//- - - ASSIGNMENT - - \\// - - Using the point recorder code, create multiple
// - - - - - - - - - - //\\ - - point recorders instead of just one. Every time 
// - - - - - - - - - - \\// - - you draw, create another point recorder. Create
// - - - - - - - - - - //\\ - - a clear function. Can you use these multiple 
// - - - - - - - - - - \\// - - point recorders to create something interesting?
// - - - - - - - - - - //\\ - - - - - - - - - - - - - - - - - - - - - - - - - - 
//--------------------------------------------------------------
void testApp::setup(){
	
	ofSetVerticalSync(true);
	ofBackground(0, 0, 0);
	
	for (int i=0; i<TPR.size(); i++) {
		TPR[i].setup();
	}
	//TPR.setup();
	playbackStartTime = 0;		
	loopingSound.loadSound("drawbar_c4_a.aif");
	loopingSound.setVolume(0);
	loopingSound.setLoop(true);
	loopingSound.play();
}
//--------------------------------------------------------------
void testApp::update(){
	//for (int i=0; i<TPR.size(); i++) {
	//	TPR[i].update();
	//}	
}
//--------------------------------------------------------------
void testApp::draw(){
	// -------------------------- draw the line
	for (int i = 0; i < TPR.size(); i++){
		TPR[i].draw();
	}
	// -------------------------- draw the point at the current time
	for(int i = 0; i<TPR.size(); i++){
		
		if (TPR[i].bHaveADrawing()){			// if we have a drawing to work with
		
		// figure out what time we are at, and make sure we playback cyclically (!)
		// use the duration here and make sure our timeToCheck is in the range of 0 - duration
		float timeToCheck = ofGetElapsedTimef() - playbackStartTime;
		while (timeToCheck > TPR[i].getDuration() && TPR[i].getDuration() > 0){
			timeToCheck -= TPR[i].getDuration();
		}
		// get the position and velocity at timeToCheck
		ofPoint pos = TPR[i].getPositionForTime(timeToCheck);
		ofPoint vel = TPR[i].getVelocityForTime(timeToCheck);
			
		// since velocity is a line, we want to know how long it is. 
		float lengthVel = ofDist(0,0,vel.x, vel.y);
			
		float soundVolume = ofMap(lengthVel, 0,200, 0,1);
		loopingSound.setVolume(soundVolume);
			
		float pitch = ofMap(pos.y, 0, (float)ofGetHeight(), 2.5, 0.1);
		loopingSound.setSpeed(pitch);
			
		float pan = ofMap(pos.x, 0, (float)ofGetWidth(), -1, 1);
		loopingSound.setPan(pan);
		
		ofEnableAlphaBlending();
		ofSetColor(200,(i*20),(255.0/i),255-lengthVel);
			
			//------//----/-////////////////
			ofBeginShape();
			for (int i = 0; i < 500; i++){
				
				ofFill(); 
				//ofSetColor(200,100,255-lengthVel, ofRandom(80,100));
				float add = ofNoise(sin((i/100.0)*TWO_PI), ofGetElapsedTimef());  // symetrical
				
				//float add = ofNoise(i/20.0f, ofGetElapsedTimef() * 3 * (float)mouseX / (float)ofGetWidth());
				
				ofVertex(pos.x + (5 + 10 * add) * cos((i/100.0)*TWO_PI), 
						 pos.y + (5 + 10 * add) * sin((i/100.0)*TWO_PI));
				
				//ofVertex(pos.x + (lengthVel*add) * cos((i/100.0)*TWO_PI), 
					//	 pos.y + (lengthVel*add) * sin((i/100.0)*TWO_PI));
			}
			ofEndShape();
			
			ofDisableAlphaBlending();
			
		//------//----/-////////////////
		//originalcode
		//ofSetColor(255,0,0);
		//ofCircle(pos.x, pos.y, 2 + lengthVel/5.0);
		}
	}	
}

//--------------------------------------------------------------
void testApp::keyPressed(int key){
	
}

//--------------------------------------------------------------
void testApp::keyReleased(int key){
	
	if (key == OF_KEY_RETURN){
		TPR.clear();
    }
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
	
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
	//TPR.addPoint(x,y);
	TPR[TPR.size()-1].addPoint(x,y);
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
	//TPR.startDrawing(x,y);
	
	timePointRecorder temp;
	
	TPR.push_back(temp); 
	TPR[TPR.size()-1].startDrawing(x,y);
}

//--------------------------------------------------------------
void testApp::mouseReleased(int x, int y, int button){
	
	for (int i = 0; i < TPR.size(); i++){
		TPR[i].endDrawing();
	}
	//TPR.endDrawing();
	playbackStartTime = ofGetElapsedTimef();
}

//--------------------------------------------------------------
void testApp::windowResized(int w, int h){
	
}



